import { Injectable } from '@angular/core';
import { SlutredovisningResponse } from '@msfa-models/api/slutredovisning.response.model';
import { DeltagareAvrop } from '@msfa-models/avrop.model';
import { DeltagareApiService } from '@msfa-services/api/deltagare.api.service';
import { HandlingarApiService } from '@msfa-services/api/handlingar.api.service';
import { Observable } from 'rxjs';
import { map } from 'rxjs/operators';
import { mapSlutredovisningResponseToSlutredovisning, Slutredovisning } from '@msfa-models/slutredovisning.model';

@Injectable()
export class SlutredovisningViewService {
  constructor(private handlingarApiService: HandlingarApiService, private deltagareApiService: DeltagareApiService) {}

  public fetchAvropInformation$(genomforandeReferens: number): Observable<DeltagareAvrop> {
    return this.deltagareApiService.fetchAvropInformation$(genomforandeReferens);
  }

  public fetchSlutredovisning$(handlingId: string): Observable<Slutredovisning> {
    return this.handlingarApiService.fetchSlutredovisning$(handlingId).pipe(
      map(({ data }) => data),
      map((slutredovisningResponse: SlutredovisningResponse) =>
        mapSlutredovisningResponseToSlutredovisning(slutredovisningResponse)
      )
    );
  }
}
